from pyrogram import filters
from pyrogram.errors.exceptions.bad_request_400 import MessageIdInvalid
from pyrogram.handlers import MessageHandler

from pyPorn import LOGS, app
from pyPorn.config import Env


class porn:
    """
    ## Main class of Pornhub Bot
    ## Available Functions:

        ``on_cmd``: Main decorator
        ``add_handler``: Add handler to bot
    """

    @classmethod
    def on_cmd(
        self,
        command: list,
        group: int = 0,
        admins_only: bool = False,
        only_pm: bool = False,
        only_groups: bool = False,
        no_sudos: bool = False,
    ):
        """
        ## Main decorator
        ### Arguments:
            ``command``: List of commands
            ``group`` (optional): Handler group (Defaults to 0)
            ``admins_only`` (optional): True if the command is only for admins (Defaults to False)
            ``only_pm`` (optional): True if the command is only for private chats (Defaults to False)
            ``only_groups`` (optional): True if the command is only for groups / supergroups (Defaults to False)
            ``no_sudos`` (optional): True if the command is restricted for sudo users (Defaults to False)
        """
        if no_sudos:
            porn_filter = (
                filters.command(command) & ~filters.edited & ~filters.forwarded
            )
        else:
            porn_filter = (
                filters.user(Env.OWNER_ID)
                & filters.command(command)
                & ~filters.edited
                & ~filters.forwarded
            )

        def decorator(func):
            async def wrapper(client, message):
                chat_type = message.chat.type
                if admins_only:
                    if chat_type in ["group", "supergroup", "channel"]:
                        usr = await app.get_me()
                        how_usr = await message.chat.get_member(usr.id)
                        if how_usr.status in ["creator", "administrator"]:
                            pass
                        else:
                            return await message.reply_text(
                                "`Pertama, Anda harus menjadi admin obrolan ini!`"
                            )
                    # It's PM Bois! Everyone is an admin in PM!
                    else:
                        pass
                if only_pm and chat_type != "private":
                    return await message.reply_text(
                        "`Yo, perintah ini hanya untuk PM!`"
                    )
                if only_groups and chat_type not in ["group", "supergroup"]:
                    return await message.reply_text("`Apakah ini bahkan grup??`")
                try:
                    await func(client, message)
                except MessageIdInvalid:
                    LOGS.warning(
                        "Jangan hapus pesan saat memproses. Ini mungkin merusak bot !"
                    )
                except BaseException:
                    pass

            self.add_handler(wrapper, porn_filter, group)
            return wrapper

        return decorator

    @classmethod
    def add_handler(self, wrapper, porn_filter, cmd_grp):
        """
        ## Add handler to the userbot
        ### Arguments:
            ``wrapper``: Callback function
            ``porn_filter``: Filters
            ``cmd_grp``: Command Group
        """
        app.add_handler(MessageHandler(wrapper, filters=porn_filter), group=cmd_grp)
