import os

from pyPorn import LOGS, app, ubot
from pyPorn.config import Env
from pyPorn.dB import get_channel_log, set_channel_log


async def log_channel():
    try:
        al_log_channel = await get_channel_log()
        if al_log_channel:
            return [True, al_log_channel]
        else:
            bot = await app.get_me()
            log_channel = await ubot.create_supergroup(
                title="Pornbot Logs",
                description="✨ My PornBot Logs \n\nChannel: @OnTheHerd \nGroup: @OTHDiskusi",
            )
            await ubot.add_chat_members(log_channel.id, bot.id)
            await ubot.promote_chat_member(log_channel.id, bot.id)
            await ubot.set_administrator_title(log_channel.id, bot.id, "Porn Bot")
            await ubot.set_chat_photo(
                chat_id=log_channel.id, photo="resources/pornbot.png"
            )
            welcome_to_pornhub = f"""
**🎉 Thank you for deploying PornBot**

**Don't forget to join @OnTheHerd and @OTHDiskusi**"""
            await set_channel_log(log_channel.id)
            await ubot.send_message(
                chat_id=log_channel.id,
                text=welcome_to_pornhub,
                disable_web_page_preview=True,
            )
            return [True, log_channel.id]
    except Exception as e:
        LOGS.warn(
            f"ERROR: \n{e} \n\nPlease check all variables and try again! \nReport this with logs at @OTHDiskusi if the problem persists!"
        )
        exit()


async def joined_chat():
    try:
        await ubot.join_chat("OnTheHerd")
        await ubot.join_chat("OTHBackup")
        await ubot.join_chat("OTHDiskusi")
        await ubot.join_chat("TestimoniOTH")
        await ubot.join_chat("ListOTHPrem")
        await ubot.join_chat("HugoSupport")
    except BaseException:
        pass


async def fetch_plugins_from_channel():
    """Fetch Plugins From Channel"""
    try:
        async for message in ubot.search_messages(
            Env.PLUGIN_CHANNEL, filter="document", query=".py"
        ):
            hmm = message.document.file_name
            if not os.path.exists(os.path.join("./funcs/", hmm)):
                await ubot.download_media(message, file_name="./funcs/")
    except BaseException as e:
        LOGS.error(f"Failed! To Install Plugins From Plugin Channel Due To {e}!")
        return
    LOGS.info("All Plugins From Plugin Channel Loaded!")
