import logging
from logging.handlers import RotatingFileHandler

from motor.motor_asyncio import AsyncIOMotorClient as Bot
from pymongo import MongoClient
from pyrogram import Client
from pytgcalls import PyTgCalls

from pyPorn.config import Env

MONGODB = Bot(Env.MONGO_URL)
db = MONGODB.Pornbot

app = Client(
    "TheBestPornhub",
    api_id=Env.API_ID,
    api_hash=Env.API_HASH,
    bot_token=Env.BOT_TOKEN,
)

ubot = Client(
    session_name=Env.STRING_SESSION,
    api_id=Env.API_ID,
    api_hash=Env.API_HASH,
)

asst = PyTgCalls(ubot)

LOG_FILE_NAME = "othprem.txt"

logging.basicConfig(
    level=logging.INFO,
    format="[%(asctime)s - %(levelname)s] - %(name)s - %(message)s",
    datefmt="%d-%b-%y %H:%M:%S",
    handlers=[
        RotatingFileHandler(LOG_FILE_NAME, maxBytes=50000000, backupCount=10),
        logging.StreamHandler(),
    ],
)
logging.getLogger("pyrogram").setLevel(logging.ERROR)
logging.getLogger("pytgcalls").setLevel(logging.ERROR)
LOGS = logging.getLogger(__name__)
