from pyPorn import db

chdb = db.channel


async def get_channel_log() -> list:
    results = []
    async for channel in chdb.find({"chat_id": {"$gt": 0}}):
        chat_id = channel["chat_id"]
        results.append(chat_id)
    return results


async def is_channel_log(chat_id: int) -> bool:
    chat = await chdb.find_one({"chat_id": chat_id})
    if not chat:
        return False
    return True


async def set_channel_log(chat_id: int):
    is_channel = await is_channel_log(chat_id)
    if is_channel:
        return
    return await chdb.insert_one({"chat_id": chat_id})
